/*
 *  (c) Copyright Enterprise Computing Research Group (ECRG),
 *  National University of Ireland, Galway 2003/2004.
 *
 *  This program is free software; you can redistribute it and/or modify it under the terms of
 *  the GNU Lesser General Public License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 *  without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE and
 *  no warranty that the program does not infringe the Intellectual Property rights of a third party.
 *  See the GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License along with this program;
 *  if not, write to the Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */
// file: JmsAgentGatewayOntology.java generated by ontology bean generator.  DO NOT EDIT, UNLESS YOU ARE REALLY SURE WHAT YOU ARE DOING!
package ie.nuigalway.ecrg.jade.jmsagentgateway.onto;

import jade.content.onto.*;
import jade.content.schema.*;
import jade.util.leap.HashMap;

import nl.uva.psy.swi.beangenerator.ProtegeIntrospector;
import nl.uva.psy.swi.beangenerator.ProtegeTools;
import nl.uva.psy.swi.beangenerator.SlotHolder;

/**
 *  file: JmsAgentGatewayOntology.java
 *
 * @author     ontology bean generator
 * @version    2004/03/31, 18:54:36
 */
public class JmsAgentGatewayOntology extends jade.content.onto.Ontology implements ProtegeTools.ProtegeOntology {
  /**
   *  These hashmap store a mapping from jade names to either protege names of
   *  SlotHolder containing the protege names. And vice versa
   */
  private HashMap jadeToProtege;

  //NAME
  /**
   *  Description of the Field
   */
  public final static String ONTOLOGY_NAME = "JmsAgentGateway";
  // The singleton instance of this ontology
  private static ProtegeIntrospector introspect = new ProtegeIntrospector();
  private static Ontology theInstance = new JmsAgentGatewayOntology();

  // VOCABULARY
  /**
   *  Description of the Field
   */
  public final static String ONMESSAGE_MESSAGE = "message";
  /**
   *  Description of the Field
   */
  public final static String ONMESSAGE = "OnMessage";
  /**
   *  Description of the Field
   */
  public final static String PUBLISHMESSAGE_PROVIDERINFO = "providerInfo";
  /**
   *  Description of the Field
   */
  public final static String PUBLISHMESSAGE_MESSAGE = "message";
  /**
   *  Description of the Field
   */
  public final static String PUBLISHMESSAGE = "PublishMessage";
  /**
   *  Description of the Field
   */
  public final static String UNSUBSCRIBE = "Unsubscribe";
  /**
   *  Description of the Field
   */
  public final static String SUBSCRIBE_SUBSCRIPTION = "subscription";
  /**
   *  Description of the Field
   */
  public final static String SUBSCRIBE_PROVIDERINFO = "providerInfo";
  /**
   *  Description of the Field
   */
  public final static String SUBSCRIBE = "Subscribe";
  /**
   *  Description of the Field
   */
  public final static String PROPERTY_PROPVALUE = "propValue";
  /**
   *  Description of the Field
   */
  public final static String PROPERTY_PROPNAME = "propName";
  /**
   *  Description of the Field
   */
  public final static String PROPERTY = "Property";
  /**
   *  Description of the Field
   */
  public final static String SUBSCRIPTION_DURABLE = "durable";
  /**
   *  Description of the Field
   */
  public final static String SUBSCRIPTION_DURABLEIDENT = "durableIdent";
  /**
   *  Description of the Field
   */
  public final static String SUBSCRIPTION_SELECTOR = "selector";
  /**
   *  Description of the Field
   */
  public final static String SUBSCRIPTION_DESTINATION = "destination";
  /**
   *  Description of the Field
   */
  public final static String SUBSCRIPTION = "Subscription";
  /**
   *  Description of the Field
   */
  public final static String PROVIDERINFO_DESTTYPE = "destType";
  /**
   *  Description of the Field
   */
  public final static String PROVIDERINFO_USERNAME = "username";
  /**
   *  Description of the Field
   */
  public final static String PROVIDERINFO_PROVIDERICF = "providerICF";
  /**
   *  Description of the Field
   */
  public final static String PROVIDERINFO_PROVIDERURL = "providerURL";
  /**
   *  Description of the Field
   */
  public final static String PROVIDERINFO_PASSWORD = "password";
  /**
   *  Description of the Field
   */
  public final static String PROVIDERINFO = "ProviderInfo";
  /**
   *  Description of the Field
   */
  public final static String JMSMESSAGE_PAYLOAD = "payload";
  /**
   *  Description of the Field
   */
  public final static String JMSMESSAGE_PRIORITY = "priority";
  /**
   *  Description of the Field
   */
  public final static String JMSMESSAGE_PROPERTIES = "properties";
  /**
   *  Description of the Field
   */
  public final static String JMSMESSAGE_DELIVERYMODE = "deliveryMode";
  /**
   *  Description of the Field
   */
  public final static String JMSMESSAGE_TIMETOLIVE = "timeToLive";
  /**
   *  Description of the Field
   */
  public final static String JMSMESSAGE_DESTINATION = "destination";
  /**
   *  Description of the Field
   */
  public final static String JMSMESSAGE = "JmsMessage";


  /**
   *  Constructor
   */
  private JmsAgentGatewayOntology() {
    super(ONTOLOGY_NAME, BasicOntology.getInstance());
    introspect.setOntology(this);
    jadeToProtege = new HashMap();
    try {

      // adding Concept(s)
      ConceptSchema jmsMessageSchema = new ConceptSchema(JMSMESSAGE);
      add(jmsMessageSchema, ie.nuigalway.ecrg.jade.jmsagentgateway.onto.JmsMessage.class);
      ConceptSchema providerInfoSchema = new ConceptSchema(PROVIDERINFO);
      add(providerInfoSchema, ie.nuigalway.ecrg.jade.jmsagentgateway.onto.ProviderInfo.class);
      ConceptSchema subscriptionSchema = new ConceptSchema(SUBSCRIPTION);
      add(subscriptionSchema, ie.nuigalway.ecrg.jade.jmsagentgateway.onto.Subscription.class);
      ConceptSchema propertySchema = new ConceptSchema(PROPERTY);
      add(propertySchema, ie.nuigalway.ecrg.jade.jmsagentgateway.onto.Property.class);

      // adding AgentAction(s)
      AgentActionSchema subscribeSchema = new AgentActionSchema(SUBSCRIBE);
      add(subscribeSchema, ie.nuigalway.ecrg.jade.jmsagentgateway.onto.Subscribe.class);
      AgentActionSchema unsubscribeSchema = new AgentActionSchema(UNSUBSCRIBE);
      add(unsubscribeSchema, ie.nuigalway.ecrg.jade.jmsagentgateway.onto.Unsubscribe.class);
      AgentActionSchema publishMessageSchema = new AgentActionSchema(PUBLISHMESSAGE);
      add(publishMessageSchema, ie.nuigalway.ecrg.jade.jmsagentgateway.onto.PublishMessage.class);
      AgentActionSchema onMessageSchema = new AgentActionSchema(ONMESSAGE);
      add(onMessageSchema, ie.nuigalway.ecrg.jade.jmsagentgateway.onto.OnMessage.class);

      // adding AID(s)

      // adding Predicate(s)

      // adding fields
      jmsMessageSchema.add(JMSMESSAGE_DESTINATION, (TermSchema) getSchema(BasicOntology.STRING), ObjectSchema.MANDATORY);
      jmsMessageSchema.add(JMSMESSAGE_TIMETOLIVE, (TermSchema) getSchema(BasicOntology.INTEGER), ObjectSchema.OPTIONAL);
      jmsMessageSchema.add(JMSMESSAGE_DELIVERYMODE, (TermSchema) getSchema(BasicOntology.BOOLEAN), ObjectSchema.MANDATORY);
      jmsMessageSchema.add(JMSMESSAGE_PROPERTIES, propertySchema, 0, ObjectSchema.UNLIMITED);
      jmsMessageSchema.add(JMSMESSAGE_PRIORITY, (TermSchema) getSchema(BasicOntology.INTEGER), ObjectSchema.OPTIONAL);
      jmsMessageSchema.add(JMSMESSAGE_PAYLOAD, (TermSchema) getSchema(BasicOntology.STRING), ObjectSchema.MANDATORY);
      providerInfoSchema.add(PROVIDERINFO_PASSWORD, (TermSchema) getSchema(BasicOntology.STRING), ObjectSchema.OPTIONAL);
      providerInfoSchema.add(PROVIDERINFO_PROVIDERURL, (TermSchema) getSchema(BasicOntology.STRING), ObjectSchema.MANDATORY);
      providerInfoSchema.add(PROVIDERINFO_PROVIDERICF, (TermSchema) getSchema(BasicOntology.STRING), ObjectSchema.MANDATORY);
      providerInfoSchema.add(PROVIDERINFO_USERNAME, (TermSchema) getSchema(BasicOntology.STRING), ObjectSchema.OPTIONAL);
      providerInfoSchema.add(PROVIDERINFO_DESTTYPE, (TermSchema) getSchema(BasicOntology.BOOLEAN), ObjectSchema.MANDATORY);
      subscriptionSchema.add(SUBSCRIPTION_DESTINATION, (TermSchema) getSchema(BasicOntology.STRING), ObjectSchema.MANDATORY);
      subscriptionSchema.add(SUBSCRIPTION_SELECTOR, (TermSchema) getSchema(BasicOntology.STRING), ObjectSchema.OPTIONAL);
      subscriptionSchema.add(SUBSCRIPTION_DURABLEIDENT, (TermSchema) getSchema(BasicOntology.STRING), ObjectSchema.OPTIONAL);
      subscriptionSchema.add(SUBSCRIPTION_DURABLE, (TermSchema) getSchema(BasicOntology.BOOLEAN), ObjectSchema.OPTIONAL);
      propertySchema.add(PROPERTY_PROPNAME, (TermSchema) getSchema(BasicOntology.STRING), ObjectSchema.MANDATORY);
      propertySchema.add(PROPERTY_PROPVALUE, (TermSchema) getSchema(BasicOntology.STRING), ObjectSchema.MANDATORY);
      subscribeSchema.add(SUBSCRIBE_PROVIDERINFO, providerInfoSchema, ObjectSchema.MANDATORY);
      subscribeSchema.add(SUBSCRIBE_SUBSCRIPTION, subscriptionSchema, ObjectSchema.MANDATORY);
      publishMessageSchema.add(PUBLISHMESSAGE_MESSAGE, jmsMessageSchema, ObjectSchema.MANDATORY);
      publishMessageSchema.add(PUBLISHMESSAGE_PROVIDERINFO, providerInfoSchema, ObjectSchema.MANDATORY);
      onMessageSchema.add(ONMESSAGE_MESSAGE, jmsMessageSchema, ObjectSchema.MANDATORY);

      // adding name mappings
      storeSlotName("destination", "ie.nuigalway.ecrg.jade.jmsagentgateway.onto.JmsMessage", "destination");
      storeSlotName("timeToLive", "ie.nuigalway.ecrg.jade.jmsagentgateway.onto.JmsMessage", "timeToLive");
      storeSlotName("deliveryMode", "ie.nuigalway.ecrg.jade.jmsagentgateway.onto.JmsMessage", "deliveryMode");
      storeSlotName("properties", "ie.nuigalway.ecrg.jade.jmsagentgateway.onto.JmsMessage", "properties");
      storeSlotName("priority", "ie.nuigalway.ecrg.jade.jmsagentgateway.onto.JmsMessage", "priority");
      storeSlotName("payload", "ie.nuigalway.ecrg.jade.jmsagentgateway.onto.JmsMessage", "payload");
      storeSlotName("password", "ie.nuigalway.ecrg.jade.jmsagentgateway.onto.ProviderInfo", "password");
      storeSlotName("providerURL", "ie.nuigalway.ecrg.jade.jmsagentgateway.onto.ProviderInfo", "providerURL");
      storeSlotName("providerICF", "ie.nuigalway.ecrg.jade.jmsagentgateway.onto.ProviderInfo", "providerICF");
      storeSlotName("username", "ie.nuigalway.ecrg.jade.jmsagentgateway.onto.ProviderInfo", "username");
      storeSlotName("destType", "ie.nuigalway.ecrg.jade.jmsagentgateway.onto.ProviderInfo", "destType");
      storeSlotName("destination", "ie.nuigalway.ecrg.jade.jmsagentgateway.onto.Subscription", "destination");
      storeSlotName("selector", "ie.nuigalway.ecrg.jade.jmsagentgateway.onto.Subscription", "selector");
      storeSlotName("durableIdent", "ie.nuigalway.ecrg.jade.jmsagentgateway.onto.Subscription", "durableIdent");
      storeSlotName("durable", "ie.nuigalway.ecrg.jade.jmsagentgateway.onto.Subscription", "durable");
      storeSlotName("propName", "ie.nuigalway.ecrg.jade.jmsagentgateway.onto.Property", "propName");
      storeSlotName("propValue", "ie.nuigalway.ecrg.jade.jmsagentgateway.onto.Property", "propValue");
      storeSlotName("providerInfo", "ie.nuigalway.ecrg.jade.jmsagentgateway.onto.Subscribe", "providerInfo");
      storeSlotName("subscription", "ie.nuigalway.ecrg.jade.jmsagentgateway.onto.Subscribe", "subscription");
      storeSlotName("message", "ie.nuigalway.ecrg.jade.jmsagentgateway.onto.PublishMessage", "message");
      storeSlotName("providerInfo", "ie.nuigalway.ecrg.jade.jmsagentgateway.onto.PublishMessage", "providerInfo");
      storeSlotName("message", "ie.nuigalway.ecrg.jade.jmsagentgateway.onto.OnMessage", "message");

      // adding inheritance

    } catch (java.lang.Exception e) {
      e.printStackTrace();
    }
  }


  /**
   *  Gets the instance attribute of the JmsAgentGatewayOntology class
   *
   * @return    The instance value
   */
  public static Ontology getInstance() {
    return theInstance;
  }

  // ProtegeOntology methods
  /**
   *  Gets the slotNameFromJADEName attribute of the JmsAgentGatewayOntology
   *  object
   *
   * @param  jadeSlot  Description of the Parameter
   * @return           The slotNameFromJADEName value
   */
  public SlotHolder getSlotNameFromJADEName(SlotHolder jadeSlot) {
    return (SlotHolder) jadeToProtege.get(jadeSlot);
  }


  // storing the information
  /**
   *  Description of the Method
   *
   * @param  jadeName       Description of the Parameter
   * @param  javaClassName  Description of the Parameter
   * @param  slotName       Description of the Parameter
   */
  private void storeSlotName(String jadeName, String javaClassName, String slotName) {
    jadeToProtege.put(new SlotHolder(javaClassName, jadeName), new SlotHolder(javaClassName, slotName));
  }
}

