/*
 *  (c) Copyright Enterprise Computing Research Group (ECRG),
 *  National University of Ireland, Galway 2003/2004.
 *
 *  This program is free software; you can redistribute it and/or modify it under the terms of
 *  the GNU Lesser General Public License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 *  without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE and
 *  no warranty that the program does not infringe the Intellectual Property rights of a third party.
 *  See the GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License along with this program;
 *  if not, write to the Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */
package ie.nuigalway.ecrg.jade.jmsagentgateway.onto;

import jade.content.*;
import jade.core.*;
import jade.util.leap.*;

/**
 *  Action requesting a message to be published Protege name: PublishMessage
 *
 * @author     ontology bean generator
 * @version    2004/03/31, 18:54:36
 */
public class PublishMessage implements AgentAction {

  /**
   *  A JMS Message Protege name: message
   */
  private JmsMessage message;

  /**
   *  Connection information for the JMS Server Protege name: providerInfo
   */
  private ProviderInfo providerInfo;


  /**
   *  Sets the message attribute of the PublishMessage object
   *
   * @param  value  The new message value
   */
  public void setMessage(JmsMessage value) {
    this.message = value;
  }


  /**
   *  Gets the message attribute of the PublishMessage object
   *
   * @return    The message value
   */
  public JmsMessage getMessage() {
    return this.message;
  }


  /**
   *  Sets the providerInfo attribute of the PublishMessage object
   *
   * @param  value  The new providerInfo value
   */
  public void setProviderInfo(ProviderInfo value) {
    this.providerInfo = value;
  }


  /**
   *  Gets the providerInfo attribute of the PublishMessage object
   *
   * @return    The providerInfo value
   */
  public ProviderInfo getProviderInfo() {
    return this.providerInfo;
  }

}

